using System;
using System.IO;
using System.Linq;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace CSharp_Shell
{

    public static class Program 
    {
        public static int index(int x, int y, int z){
            return ((y * 1000) + x) * 32 + z;
        }
        public static void Main() 
        {
           var arr = new int[32000000];
           Parallel.For(0, 32, (int d) => {
               for(int y = 0; y < 1000; y++){
                   for(int x = 0; x < 1000; x++){
                       arr[index(x, y, d)] = d;
                   }
               }
           });
           var dt = DateTime.Now;
           Parallel.For(0, 32, (int d) => {
               for(int y = 0; y < 1000; y++){
                   for(int x = 0; x < 1000; x++){
                       arr[index(x, y, d)] = d;
                   }
               }
           });
           Console.WriteLine((DateTime.Now - dt).TotalMilliseconds);
           dt = DateTime.Now;
           Parallel.For(0, 1000, (int y) => {
               for(int x = 0; x < 1000; x++){
                   for(int d = 0; d < 32; d++){
                       arr[index(x, y, d)] = d;
                   }
               }
           });
           Console.WriteLine((DateTime.Now - dt).TotalMilliseconds);
        }
    }
}